package FirstBean;

import java.beans.*;

public class FirstBeanBeanInfo extends SimpleBeanInfo {

    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            PropertyDescriptor label =
			new PropertyDescriptor("string", beanClass);

            label.setBound(true);

            PropertyDescriptor rv[] = { label };
            return rv;
        } catch (IntrospectionException e) {
            throw new Error(e.toString());
        }
    }


    public int getDefaultPropertyIndex() {
	// the index for the "string" property
        return 0; 
    }


    public EventSetDescriptor[] getEventSetDescriptors() {
        try {
            EventSetDescriptor push = new EventSetDescriptor(beanClass, 
	                "actionPerformed",
			java.awt.event.ActionListener.class,
			"actionPerformed");

            EventSetDescriptor changed = new EventSetDescriptor(beanClass,
			"propertyChange",
			java.beans.PropertyChangeListener.class,
			"propertyChange");

            push.setDisplayName("button push");
            changed.setDisplayName("bound property change");
	
            EventSetDescriptor[] rv = { push, changed};
            return rv;
        } catch (IntrospectionException e) {
            throw new Error(e.toString());
        }
    }

    public BeanDescriptor getBeanDescriptor() {
        return new BeanDescriptor(beanClass, customizerClass);
    }

    public java.awt.Image getIcon(int iconKind) {
	if (iconKind == BeanInfo.ICON_MONO_16x16 ||
	    iconKind == BeanInfo.ICON_COLOR_16x16 ) {
	    java.awt.Image img = loadImage("FirstBean16.gif");
	    return img;
	}
	return null;
    }

    private final static Class beanClass = FirstBean.class;
    private final static Class customizerClass = FirstBeanCustomizer.class;
}

