package sunw.demo.listview;

import java.util.Vector;
import java.awt.*;
import java.awt.event.*;

public class ListView extends Component implements MouseListener,
				 MouseMotionListener, KeyListener
{
  Vector listItems;
  int viewMode;
  Vector columnHeaders;
  int detailCount;
  ListItem selected;
  Vector pushListeners = new Vector();

  public static final int ICONVIEW = 0;
  public static final int DETAILVIEW = 1;
   
  // Class initialization code
  ListView(int dcount) {
    this(dcount, ICONVIEW);
  }

  ListView(int dcount, int mode) {
    detailCount = dcount;
    viewMode = mode;
    listItems = new Vector();
    columnHeaders = new Vector();
//    addKeyListener(this);
    addMouseListener(this);
    addMouseMotionListener(this);
  }

  public String getViewMode() { return viewMode; };

  public void setViewMode(int mode) { 
    if (viewMode != mode) {
      viewMode = mode;
      ResetView(viewMode);
    }
  };

  public void addListItem(ListItem item) {
    listItems.addElement(item);
  }

  public boolean removeListItem(ListItem item) {
    listItems.removeElement(item);
  }

  public Dimension getPreferredSize() {
/*
    if (listItems.size() > 0)
      if (orientation == ToolBar.HORIZONTAL) {
        return new Dimension(origin.x, ((Tool) listItems.elementAt(0)).height());
      }
      else if (orientation == ToolBar.VERTICAL) {
        return new Dimension(((Tool) listItems.elementAt(0)).width(), origin.y);
      }
    return new Dimension(100, 50);
*/
    return getParent().getSize();
  }
  
  public Dimension getMinimumSize() {
    return new Dimension(100, 50);
  }

  public synchronized void addActionListener(ActionListener l) {
    pushListeners.addElement(l);
  }
 
  public synchronized void removeActionListener(ActionListener l) {
    pushListeners.removeElement(l);
  }
 
  public void ReArrainge() {
    if (listItems.size() > 0) {
      int indx = 0;
      int dx = ((Demension)((ListItem) listItems.elementAt(0)).getSize()).height;
      int dy = ((Demension)((ListItem) listItems.elementAt(0)).getSize()).width;
      Point origin = new Point(0, 0);
      int rows = getSize().height / dy;
      int r = 0, c = 0;
      for (int i = 0; i < listItems.size(); i++)
      {
        ListItem t = (ListItem) listItems.elementAt(i);
        t.setItemIndex(indx);
        t.setOrigin(Point(c * dx, r * dy));
        r += 1;
        if (viewMode == ListView.ICONVIEW) {
          if (r >= rows) {
            rows = 0; c += 1;
          }
        }
      }
    }
  }

  public void mouseClicked(MouseEvent e) {}

  public void mousePressed(MouseEvent e) {
    for (int i = 0; i < listItems.size(); i++)
    {
      ListItem t = (ListItem) listItems.elementAt(i);
      t.pressed = false;
      if (t.hasPoint(e.getX(), e.getY()))
        t.mouseDown(e);
    }
  }

  public void mouseReleased(MouseEvent e) {
    for (int i = 0; i < listItems.size(); i++)
    {
      ListItem t = (ListItem) listItems.elementAt(i);
      if (t.hasPoint(e.getX(), e.getY())) 
        t.mouseUp(e);
    }
    if (selected != null)
    {
      selected.mouseExit(e);
      selected.pressed = false;
      selected = null;
    }
  }

  public void mouseEntered(MouseEvent e) {
    for (int i = 0; i < listItems.size(); i++)
    {
      ListItem t = (ListItem) listItems.elementAt(i);
      if (t.hasPoint(e.getX(), e.getY())) {
        selected = t;
        t.mouseEnter(e);
      }
    }
  }

  public void mouseExited(MouseEvent e) {
    for (int i = 0; i < listItems.size(); i++)
    {
      ListItem t = (ListItem) listItems.elementAt(i);
      t.mouseExit(e);
    }
    if (selected != null)
    {
      selected.pressed = false;
      selected = null;
    }
  }

  public void mouseDragged(MouseEvent e) {}

  public void mouseMoved(MouseEvent e) {
    for (int i = 0; i < listItems.size(); i++)
    {
      ListItem t = (ListItem) listItems.elementAt(i);
//          t.mouseExit(e);
      if (t.hasPoint(e.getX(), e.getY())) {
        selected.mouseExit(e);
        selected = t;
        t.mouseEnter(e);
      }
    }
  }

  // This routine handles the painting
  public synchronized void paint(Graphics graphic)
  {
    graphic.setColor(getBackground());
    graphic.fillRect( 0, 0, getSize().width, getSize().height);
    if (listItems != null) 
      for (int i = 0; i < listItems.size(); i++)
      {
        ((ListItem) listItems.elementAt(i)).paint(graphic);
      }
  }
} // end class ListView
