package sunw.demo.simplest;

import java.awt.*;
import java.awt.event.*;

public class ToolSeparator extends Tool
{
  Component Parent;

  // Class initialization code
  ToolSeparator(Component parent, Point origin, int orient)
  {
    Parent = parent;
    pressed = false;
    mouseIn = false;
    if (orient == 0) { // HORIZONTAL
      ImgWidth = 10;
      ImgHeight = 20;
    } else if (orient == 1) { // VERTICAL
      ImgWidth = 20;
      ImgHeight = 10;
    }
    x = origin.x;
    y = origin.y;
  }

  public int width()
  {
    return ImgWidth + 4;
  }

  public int height()
  {
    return ImgHeight + 4;
  }

  public void setOrigin(Point origin, int orient)
  {
    x = origin.x;
    y = origin.y;
    if (orient == 0) { // HORIZONTAL
      ImgWidth = 10;
      ImgHeight = 20;
    } else if (orient == 1) { // VERTICAL
      ImgWidth = 20;
      ImgHeight = 10;
    }
  }

  public boolean mouseEnter(MouseEvent event)
  {
    mouseIn = true;
    return true;
  }

  // Mouse button pressed handling code
  public boolean mouseExit(MouseEvent event)
  {
    mouseIn = false;
    return true;
  }

  // Mouse button pressed handling code
  public boolean mouseDown(MouseEvent event)
  {
    return true;
  }

  // Mouse button released handling code
  public boolean mouseUp(MouseEvent event)
  {
    return true;
  }

  public boolean hasPoint(int x, int y)
  {
    if (x > this.x && x < this.x + ImgWidth + 4)
      if (y > this.y && y < this.y + ImgHeight + 4)
        return true;
    return false;
  }

  public void repaint()
  {
    paint(Parent.getGraphics());
  }

  // This routine handles the painting
  public void paint(Graphics graphic)
  {
    graphic.clearRect( x, y, x + ImgWidth + 4, y + ImgHeight + 4);
  }
} // end class ToolSeparator
